#!/usr/bin/env python2
# -*- coding: UTF-8 -*-
# vim: autoindent expandtab tabstop=4 sw=4 sts=4 filetype=python

"""
This check for nrpe grabs a status-code from mirror json-files
and return 0 (ok) if sync was ok or 1 (warning) if it wasn't.
"""

# Copyright (c) 2015, Adfinis SyGroup AG
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the Adfinis SyGroup AG nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS";
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Adfinis SyGroup AG BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


# System Imports
import sys
import json

def usage():
    print "Usage: %s <jsonfile>" % sys.argv[0]

def main():

    data = ""

    try:
        f = open(sys.argv[1], 'r')
        data = f.read()
    except IndexError:
        usage()
        sys.exit(3)
    except IOError:
        print "File '%s' not found" % sys.argv[1]
        sys.exit(3)
    except ValueError:
        print "Json could not be decoded"
        sys.exit(3)

    mirror_time   = json.loads(data)['time']
    mirror_size   = json.loads(data)['size']
    mirror_status = json.loads(data)['status']

    if (mirror_status == '0' or mirror_status == '24'):
        print 'Status: OK, Last sync: %s, Size: %s' % (mirror_time, mirror_size)
        return 0
    elif mirror_status == '-1':
        print 'Status: up to date, Last sync: %s, Size: %s' % (mirror_time, mirror_size)
        return 0
    else:
        print 'Status: Critical, Exitcode: %s, Last sync: %s, Size: %s' % (mirror_status, mirror_time, mirror_size)
        return 1

if __name__ == "__main__":
    sys.exit(main())
